package sb.finder;

//import java.io.File;
//import java.io.FilenameFilter;
import java.net.URL;
import javax.swing.JOptionPane;

public class Finder {

	public static void main(String[] args) {								
		
		boolean lowVer = false;
		String javaVer = System.getProperty("java.version");
		if(javaVer != null) { 
			int idx0 = javaVer.indexOf('.');
			int idx1 = -1;
			String ver0 = javaVer;
			String ver1 = "-1";
			if (idx0 != -1) {
				ver0 = javaVer.substring(0, idx0);
				idx1 = javaVer.indexOf('.', idx0 + 1);
				if (idx1 != -1)
					ver1 = javaVer.substring(idx0 + 1, idx1);
			}
			int iver0 = -1;
			int iver1 = -1;
			lowVer = true;
			try {
				iver0 = Integer.parseInt(ver0);
				iver1 = Integer.parseInt(ver1);
			} catch (Exception exc) {
				lowVer = false;
				exc.printStackTrace();
			}
			if (lowVer)
				if (iver0 >= 1)
					if (iver1 >= 4)
						lowVer = false;								
		}				
		
		if (lowVer) {
			String verMismatch = Context.myName + ": Java version 1.4 or higher is required. But current is "
					+ System.getProperty("java.version");
			System.out.println(verMismatch);
			try {
				// AlertDialog.showErrorDialog(verMismatch);
				// AlertDialog cannot be used before the ClassPathHacker's job
				JOptionPane.showMessageDialog(null, verMismatch, "Error",
						JOptionPane.ERROR_MESSAGE);
			} catch (Exception e) {
				e.printStackTrace();
			}
			System.exit(1);
		}						
		
		Finder finder = new Finder();		
		
		URL url = finder.getClass().getResource(Context.myPackagePath + "Finder.class");
		if(url == null) {
			System.out.println(Context.myName + ": Cannot get the URL for the class: " + 
					Context.myPackagePath + "Finder.class");
			System.exit(1);
		}		
		
		String homeDir = url.getFile();
		if (homeDir.startsWith("file:"))
			homeDir = homeDir.substring(5);
		int idx = homeDir.indexOf('!');
		if (idx != -1)
			homeDir = homeDir.substring(0, idx);
		idx = homeDir.lastIndexOf('/');
		if (idx != -1)
			homeDir = homeDir.substring(0, idx);
		idx = homeDir.lastIndexOf('/');
		if (idx != -1) {
			if(homeDir.substring(idx + 1).toLowerCase().equals("lib"))
				homeDir = homeDir.substring(0, idx);
		}
		homeDir = homeDir.replaceAll("%20", " ");			
		
		Context.homeDir = homeDir + "/";
		System.out.println(Context.myName + ": Assuming " + Context.myName + " home dir is: " + homeDir);

		try {
			ClassPathHacker.addFile(Context.homeDir + "conf");
/*			
			File jmDir = new File(Context.homeDir + "lib/javamail/");
			if(jmDir.exists()) {
				File jars[] = jmDir.listFiles(new FilenameFilter() {
					public boolean accept(File dir, String name) {
						return (name.toLowerCase().indexOf(".jar") == name.length() - 4);
					}					
				});
				for(int i = 0; i < jars.length; i++) {
					ClassPathHacker.addFile(Context.homeDir + "lib/javamail/" + jars[i].getName());		
				}
			}
*/						
//			ClassPathHacker.addFile(Context.homeDir + "lib/" + "activation.jar");
			ClassPathHacker.addFile(Context.homeDir + "lib/" + "om-core.jar");
		} catch (Exception e) {
			e.printStackTrace();
		}	
			
		finder.go();
	}
		
	public void go() {
		MainFrame mf = new MainFrame();
		mf.setVisible(true);	
	}
	
}
